// UmtsCodeView.cpp : implementation of the CUmtsCodeView class
//

#include "stdafx.h"
#include "UmtsCode.h"

#include "UmtsCodeDoc.h"
#include "UmtsCodeView.h"
#include ".\umtscodeview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CString str1="UMTS";
CString str2="GPRS";
CString str3="OKAY";
CString str4="READ";

int vector1[4]={1,1,1,1};
int vector2[4]={1,-1,-1,1};
int vector3[4]={1,1,-1,-1};
int vector4[4]={1,-1,1,-1};


int iResultFlag=0;

int chip[4]={0,0,0,0};

int chipserie[2000][4];
int chipindex=0;

int xx1,yy1;
int xx2,yy2;
int xx3,yy3;
int ivalue,ii;



// CUmtsCodeView

IMPLEMENT_DYNCREATE(CUmtsCodeView, CView)

BEGIN_MESSAGE_MAP(CUmtsCodeView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID_BUT_RESULT, OnButResult)
END_MESSAGE_MAP()

// CUmtsCodeView construction/destruction

CUmtsCodeView::CUmtsCodeView()
{
	// TODO: add construction code here
}

CUmtsCodeView::~CUmtsCodeView()
{
}

BOOL CUmtsCodeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}

// CUmtsCodeView drawing

void CUmtsCodeView::OnDraw(CDC* pDC)
{
	CUmtsCodeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)	return;

	// TODO: 
	pDC->SetMapMode( MM_TWIPS );
	pDC->SelectObject(&m_font);	

	xx1 =  500;  yy1 =  -500;
	xx2 = 3200;  yy2 =  -500;
 	#define ddy 300 

	CString strx;
	strx.Format("Vector1:%2d,%2d,%2d,%2d",vector1[0],vector1[1],vector1[2],vector1[3]);
	pDC->TextOut(xx1,yy1,strx); yy1-=ddy;
	strx.Format("Vector2:%2d,%2d,%2d,%2d",vector2[0],vector2[1],vector2[2],vector2[3]);
	pDC->TextOut(xx1,yy1,strx); yy1-=ddy;
	strx.Format("Vector3:%2d,%2d,%2d,%2d",vector3[0],vector3[1],vector3[2],vector3[3]);
	pDC->TextOut(xx1,yy1,strx); yy1-=ddy;
	strx.Format("Vector4:%2d,%2d,%2d,%2d",vector4[0],vector4[1],vector4[2],vector4[3]);
	pDC->TextOut(xx1,yy1,strx); yy1-=ddy;
	yy1-=ddy;


	
	if(iResultFlag) pDC->TextOut(xx1,yy1,str1); 
	yy1-=ddy;
	if(iResultFlag)pDC->TextOut(xx1,yy1,str2);
	yy1-=ddy;
	if(iResultFlag) pDC->TextOut(xx1,yy1,str3);
	yy1-=ddy;
	if(iResultFlag)pDC->TextOut(xx1,yy1,str4);
	yy1-=ddy;
    yy1-=ddy;


	

	strx.Empty();
	int index=0;
	unsigned char chx1,chx2,chx3,chx4;
	CString strbin1,strbin2,strbin3,strbin4;
	chipindex=0;

	while(index < str1.GetLength())
	{
	chx1 = str1.GetAt(index);
	chx2 = str2.GetAt(index);
	chx3 = str3.GetAt(index);
	chx4 = str4.GetAt(index);

	strbin1="00000000";
	if(chx1 & 0x80) strbin1.SetAt(0,'1');
	if(chx1 & 0x40) strbin1.SetAt(1,'1');
	if(chx1 & 0x20) strbin1.SetAt(2,'1');
	if(chx1 & 0x10) strbin1.SetAt(3,'1');
	if(chx1 & 0x08) strbin1.SetAt(4,'1');
	if(chx1 & 0x04) strbin1.SetAt(5,'1');
	if(chx1 & 0x02) strbin1.SetAt(6,'1');
	if(chx1 & 0x01) strbin1.SetAt(7,'1');

	strx.Format("%c %s",chx1,strbin1);
	if(iResultFlag) pDC->TextOut(xx1,yy1,strx); 
	yy1-=ddy;

	strbin2="00000000";
	if(chx2 & 0x80) strbin2.SetAt(0,'1');
	if(chx2 & 0x40) strbin2.SetAt(1,'1');
	if(chx2 & 0x20) strbin2.SetAt(2,'1');
	if(chx2 & 0x10) strbin2.SetAt(3,'1');
	if(chx2 & 0x08) strbin2.SetAt(4,'1');
	if(chx2 & 0x04) strbin2.SetAt(5,'1');
	if(chx2 & 0x02) strbin2.SetAt(6,'1');
	if(chx2 & 0x01) strbin2.SetAt(7,'1');
	strx.Format("%c %s",chx2,strbin2);
	if(iResultFlag)pDC->TextOut(xx1,yy1,strx);
	yy1-=ddy;
	
	strbin3="00000000";
	if(chx3 & 0x80) strbin3.SetAt(0,'1');
	if(chx3 & 0x40) strbin3.SetAt(1,'1');
	if(chx3 & 0x20) strbin3.SetAt(2,'1');
	if(chx3 & 0x10) strbin3.SetAt(3,'1');
	if(chx3 & 0x08) strbin3.SetAt(4,'1');
	if(chx3 & 0x04) strbin3.SetAt(5,'1');
	if(chx3 & 0x02) strbin3.SetAt(6,'1');
	if(chx3 & 0x01) strbin3.SetAt(7,'1');
	strx.Format("%c %s",chx3,strbin3);
	if(iResultFlag)pDC->TextOut(xx1,yy1,strx);
	yy1-=ddy;

	strbin4="00000000";
	if(chx4 & 0x80) strbin4.SetAt(0,'1');
	if(chx4 & 0x40) strbin4.SetAt(1,'1');
	if(chx4 & 0x20) strbin4.SetAt(2,'1');
	if(chx4 & 0x10) strbin4.SetAt(3,'1');
	if(chx4 & 0x08) strbin4.SetAt(4,'1');
	if(chx4 & 0x04) strbin4.SetAt(5,'1');
	if(chx4 & 0x02) strbin4.SetAt(6,'1');
	if(chx4 & 0x01) strbin4.SetAt(7,'1');
	strx.Format("%c %s",chx4,strbin4);
	if(iResultFlag)pDC->TextOut(xx1,yy1,strx);
	yy1-=ddy;
	yy1-=ddy;


	ii=7;
	while(ii >=0 )
	{
	if(strbin1.GetAt(ii) == '1') ivalue=1; else ivalue = -1;
	chip[0] = vector1[0] * ivalue;
	chip[1] = vector1[1] * ivalue;
	chip[2] = vector1[2] * ivalue;
	chip[3] = vector1[3] * ivalue;

	if(strbin2.GetAt(ii) == '1') ivalue=1; else ivalue = -1;
	chip[0] += vector2[0] * ivalue;
	chip[1] += vector2[1] * ivalue;
	chip[2] += vector2[2] * ivalue;
	chip[3] += vector2[3] * ivalue;
	
	if(strbin3.GetAt(ii) == '1') ivalue=1; else ivalue = -1;
	chip[0] += vector3[0] * ivalue;
	chip[1] += vector3[1] * ivalue;
	chip[2] += vector3[2] * ivalue;
	chip[3] += vector3[3] * ivalue;

	if(strbin4.GetAt(ii) == '1') ivalue=1; else ivalue = -1;
	chip[0] += vector4[0] * ivalue;
	chip[1] += vector4[1] * ivalue;
	chip[2] += vector4[2] * ivalue;
	chip[3] += vector4[3] * ivalue;

	strx.Format("Chip%02d = %2d,%2d,%2d,%2d",chipindex,chip[0],chip[1],chip[2],chip[3]);
	pDC->TextOut(xx2,yy2,strx); yy2 -= ddy;

	chipserie[chipindex][0]  = chip[0];
	chipserie[chipindex][1]  = chip[1];
	chipserie[chipindex][2]  = chip[2];
	chipserie[chipindex][3]  = chip[3];

    chipindex++;
	ii--;
	}
	
	yy2 -= ddy;
	index++;
	}





//************ decode *********************************
	int line=0;
	int chipxx;
	chipxx=0;
	char bitx;
	int bit1,bit2,bit3,bit4;
	int add1,add2,add3,add4;
	yy3 =  -500;
	#define ddx 2600

	if(iResultFlag)
	while(chipxx < chipindex)
	{
	xx3 = 6000;
    bit1  = chipserie[chipxx][0] * vector1[0];
	bit2  = chipserie[chipxx][1] * vector1[1];
	bit3  = chipserie[chipxx][2] * vector1[2];
	bit4  = chipserie[chipxx][3] * vector1[3];
	add1 = bit1+bit2+bit3+bit4;
	if(add1 >= 0) bitx='1'; else bitx='0';
	strx.Format("%2d,%2d,%2d,%2d %2d '%c'",bit1,bit2,bit3,bit4,add1,bitx);
	pDC->TextOut(xx3,yy3,strx); 
	xx3 += ddx;

    bit1  = chipserie[chipxx][0] * vector2[0];
	bit2  = chipserie[chipxx][1] * vector2[1];
	bit3  = chipserie[chipxx][2] * vector2[2];
	bit4  = chipserie[chipxx][3] * vector2[3];
	if(add1 >= 0) bitx='1'; else bitx='0';
	strx.Format("%2d,%2d,%2d,%2d %2d '%c'",bit1,bit2,bit3,bit4,add1,bitx);
	pDC->TextOut(xx3,yy3,strx); 
	xx3 += ddx;

    bit1  = chipserie[chipxx][0] * vector3[0];
	bit2  = chipserie[chipxx][1] * vector3[1];
	bit3  = chipserie[chipxx][2] * vector3[2];
	bit4  = chipserie[chipxx][3] * vector3[3];
	add1 = bit1+bit2+bit3+bit4;
	if(add1 >= 0) bitx='1'; else bitx='0';
	strx.Format("%2d,%2d,%2d,%2d %2d '%c'",bit1,bit2,bit3,bit4,add1,bitx);
	pDC->TextOut(xx3,yy3,strx); 
	xx3 += ddx;

    bit1  = chipserie[chipxx][0] * vector4[0];
	bit2  = chipserie[chipxx][1] * vector4[1];
	bit3  = chipserie[chipxx][2] * vector4[2];
	bit4  = chipserie[chipxx][3] * vector4[3];
	if(add1 >= 0) bitx='1'; else bitx='0';
	strx.Format("%2d,%2d,%2d,%2d %2d '%c'",bit1,bit2,bit3,bit4,add1,bitx);
	pDC->TextOut(xx3,yy3,strx); 


	yy3 -= ddy;
	chipxx++;
	line++;
	if(line==8){line=0; yy3 -= ddy;}
	}
}


// CUmtsCodeView printing

BOOL CUmtsCodeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CUmtsCodeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CUmtsCodeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CUmtsCodeView diagnostics

#ifdef _DEBUG
void CUmtsCodeView::AssertValid() const
{
	CView::AssertValid();
}

void CUmtsCodeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CUmtsCodeDoc* CUmtsCodeView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CUmtsCodeDoc)));
	return (CUmtsCodeDoc*)m_pDocument;
}
#endif //_DEBUG


// CUmtsCodeView message handlers

void CUmtsCodeView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
	// TODO:

	memset(&logfont, 0, sizeof(logfont)); // view font
	logfont.lfHeight= 6*34;
	logfont.lfWidth = 4*32;
	CString szFont;
	szFont.LoadString(IDS_FONT_NAME); 
	lstrcpy(logfont.lfFaceName, szFont);
	VERIFY(m_font.CreateFontIndirect(&logfont));
	SetFont( &m_font );	

	memset(&logfont1, 0, sizeof(logfont1));  // printer font
	logfont1.lfHeight= 5*32;
	logfont1.lfWidth = 3*30;
	CString szFont1;
	szFont1.LoadString(IDS_FONT_NAME);
	lstrcpy(logfont1.lfFaceName, szFont1);
	VERIFY(m_font1.CreateFontIndirect(&logfont1));
	SetFont( &m_font1 );	

}

void CUmtsCodeView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: 
pDC->SelectObject(&m_font1);	
	pDC->SetMapMode( MM_TWIPS );
	CView::OnPrepareDC(pDC, pInfo);
}





void CUmtsCodeView::OnButResult() 
{
if(iResultFlag) iResultFlag=0; else iResultFlag=1; 
Invalidate();	
}